<!DOCTYPE html>
<html lang="en" dir="ltr">
  <head>
    <meta charset="utf-8">
    <title>Callback page for OIDC JS Client Stub for AuRa</title>
    <style>
      #debuggingInfo {
        border: 1px dotted black;
        padding: 0.5em;
        margin-bottom: 1em;
        word-break: break-all;
      }
    </style>
  </head>
  <body>
    <h1>OIDC callback page</h1>
    Debugging info:
    <div id="debuggingInfo"></div>
    <button onclick="finish_flow()">Finish the OIDC flow and return to index.html</button>
    <script>
      // extract the relevant query parameters with the token info
      let params = new URLSearchParams(String(location).split('#', 2)[1])
      let id_token_contents = null
      if (params.has("id_token")) {
        id_token_contents = JSON.parse(
          atob(params.get("id_token").split('.')[1])
        )
      }

      // store it in localStorage, so that index.html can access it later
      localStorage.user = JSON.stringify({
        access_token: params.get("access_token"),
        id_token: params.get("id_token"),
        id_token_contents: id_token_contents,
        code: params.get("code"),
      })

      let div = document.getElementById("debuggingInfo")
      div.innerText = localStorage.user

      // in a production setup the browser should be forwarded automatically
      // but here we want wait for the user to press the button, except
      // debugging is disabled
      const finish_flow = function () {
        location.assign("index.html")
      }
      if (localStorage.oidcCallbackDebugging === undefined) {
        finish_flow()
      }
    </script>
  </body>
</html>
